#ifndef DM_H
#define DM_H

#include <cyg/kernel/kapi.h>
#include <cyg/io/io.h>
#include <cyg/hal/hal_tables.h>

#ifndef NO_SOCKETSERVER
extern int serverSaveConfig(void);
#endif

typedef void void_fun(void);
typedef void_fun *void_fun_ptr;
struct init_tab_entry 
{
  void_fun_ptr fun;
} CYG_HAL_TABLE_TYPE;

struct diag_tab_entry
{
  void_fun_ptr fun;
  char cmd;
  char *str;
};

#define _DeviceMaster_diag(_f_,_c_,_s_)  \
struct diag_tab_entry _diag_tab_##_f_ CYG_HAL_TABLE_QUALIFIED_ENTRY(DeviceMaster_diag,_f_) = {_f_,_c_,_s_};
#define DeviceMaster_diag(_f_,_c_,_s_) _DeviceMaster_diag(_f_,_c_,_s_)

// provide single access point for serial ports

typedef struct
{
  cyg_sem_t  ownership;
  cyg_io_handle_t handle;
}tDevMastPort;

#define DevMastMaxPorts 32
#define MAX_VERSIONSTRING_SIZE 64

tDevMastPort devMastPort[DevMastMaxPorts];

/* mode values written to EPLD to control which line drivers/receivers
 * are used, and a function to do it.
 */
#define DevMastRsMode_232  0x00
#define DevMastRsMode_232I 0x18
#define DevMastRsMode_422  0x08
#define DevMastRsMode_485  0x10

extern volatile unsigned PioMode;
extern volatile unsigned PioData;
#define Bit(n) (1<<(n))

#define LedEnable() PioMode |= Bit(15)
#define LedOff() PioData |= Bit(15)
#define LedOn()  PioData &= ~Bit(15)
#define LedToggle() PioData ^= Bit(15)

extern void ddiag_printf(const char *fmt, ...);
#define diag_printf ddiag_printf

//  Task monitoring stuff
#define TASK_ETHER_RX  1
#define TASK_TCP_RX    2
#define TASK_RPSH_POLL 3
#define TASK_END_LIST  4


typedef struct {
    unsigned int taskNumber;
    unsigned char taskName[80];
    unsigned int awakeCount;
    unsigned int lastCount;
} taskList_t;

extern char linkTimeStamp[];
extern char versionString[];

/*  Prototypes for task init functions */
void madminInit(void);
void tadminInit(void);
void snmpInit(void);
void serverInit(void);
void webServerInit(void);
void telnetsrvInit(void);
void portmonInit(void);


/*  Other prototypes */
unsigned long myIpAddr(void);
unsigned long myIpMask(void);
unsigned long myIpGate(void);
int ModelIsRs232Only(void);
int ModelIsAir(void);
int ModelHasRI(void);

#endif

